TOOL.Category		= "Constraints"
TOOL.Name			= "#Quick Everything"
TOOL.Command		= nil
TOOL.ConfigName		= ""

TOOL.ClientConVar["weld"] = 1
TOOL.ClientConVar["nocollide"] = 0
TOOL.ClientConVar["enablenocollideworld"] = 0
TOOL.ClientConVar["disablenocollideworld"] = 0
TOOL.ClientConVar["enablenocollideall"] = 0
TOOL.ClientConVar["disablenocollideall"] = 0
TOOL.ClientConVar["enableshadow"] = 0
TOOL.ClientConVar["disableshadow"] = 0
TOOL.ClientConVar["freeze"] = 0
TOOL.ClientConVar["unfreeze"] = 0
TOOL.ClientConVar["enablegravity"] = 0
TOOL.ClientConVar["disablegravity"] = 0
TOOL.ClientConVar["changeweight"] = 0
TOOL.ClientConVar["weight"] = 1
TOOL.ClientConVar["changematerial"] = 0
TOOL.ClientConVar["material"] = "metal_bouncy"
TOOL.ClientConVar["changecolor"] = 0
TOOL.ClientConVar["colorr"] = 255
TOOL.ClientConVar["colorg"] = 255
TOOL.ClientConVar["colorb"] = 255
TOOL.ClientConVar["colora"] = 255
TOOL.ClientConVar["changematerialtexture"] = 0
TOOL.ClientConVar["materialtexture"] = "debug/env_cubemap_model"

TOOL.SelectedProps = {}

if CLIENT then
	language.Add("Tool_quickeverything_name", "Quick Everything")
	language.Add("Tool_quickeverything_desc", "Quickly apply settings to props.")
	language.Add("Tool_quickeverything_0", "Primary: Select/Deselect Prop   Secondary: Process Props   Reload: Deselect All")
end


local function SetMass(Player, Entity, Data)
	if not SERVER then return end

	if (Entity:IsValid()) then
		if Data.Mass then
			local physobj = Entity:GetPhysicsObject()
			if physobj:IsValid() then physobj:SetMass(Data.Mass) end
		end
	end
	
	duplicator.StoreEntityModifier(Entity, "mass", Data)
end

local function SetGravity(Player, Entity, Data)
	if not SERVER then return end

	if (Entity:IsValid()) then
		local physobj = Entity:GetPhysicsObject()
		if physobj:IsValid() then
			if (Data.Gravity == 1) then
				physobj:EnableGravity(true)
			else
				physobj:EnableGravity(false)
			end
		end
	end
	
	duplicator.StoreEntityModifier(Entity, "gravity", Data)
end

local function SetShadow(Player, Entity, Data)
	if not SERVER then return end

	if Entity:IsValid() then
		if (Data.Shadow == 1) then
			Entity:DrawShadow(true)
		else
			Entity:DrawShadow(false)
		end
	end
	
	duplicator.StoreEntityModifier(Entity, "shadow", Data)
end

function SetMaterialTexture(Undo, Entity, Data)
	if not SERVER then return end

	if (Entity:IsValid() && Data != nil) then
		Entity:SetMaterial(Data.MaterialTexture)
	end

	duplicator.StoreEntityModifier(Entity, "materialtexture", Data)
end

function SetColor(Undo, Entity, Data)
	if not SERVER then return end

	if (Entity:IsValid() && Data != nil) then
		Entity:SetColor(Data.R, Data.G, Data.B, Data.A)
	end

	duplicator.StoreEntityModifier(Entity, "color", Data)
end

function SetCollisionGroup(Undo, Entity, Data)
	if not SERVER then return end

	if (Entity:IsValid()) then// && Data != nil) then
		Entity:SetCollisionGroup(Data.CollisionGroup)
		Entity.CollisionGroup = Data.CollisionGroup
	end

	duplicator.StoreEntityModifier(Entity, "collisiongroup", Data)
end

duplicator.RegisterEntityModifier("mass",SetMass)
duplicator.RegisterEntityModifier("gravity",SetGravity)
duplicator.RegisterEntityModifier("shadow",SetShadow)
duplicator.RegisterEntityModifier("materialtexture",SetMaterialTexture)
duplicator.RegisterEntityModifier("color",SetColor)
duplicator.RegisterEntityModifier("collisiongroup",SetCollisionGroup)

function SetMaterial(Undo, Entity, Bone, Material)
	if not SERVER then return end

	if (Entity:IsValid() && Material != nil && Bone != nil) then
		construct.SetPhysProp(Player, Entity, Bone, nil,{GravityToggle = nil, Material = Material.Material})
	end
end

function SetAdvBallSocket(p1, p2)
	if not SERVER then return end

	return constraint.AdvBallsocket(
		p1.ent,
		p2,
		p1.bone,
		0,
		Vector(0,0,0),
		Vector(0,0,0),
		0, 0, -180, -180, -180, 180, 180, 180, 0, 0, 0, 1, 1) //Last 2: OnlyRotation, NoCollide //:GetLocalPos()
end

function TOOL:SelectEnt(ent,bone)
	local Prop = {}
	Prop.ent = ent
	Prop.bone = bone
	Prop.r, Prop.g, Prop.b, Prop.a = ent:GetColor()
	table.insert(self.SelectedProps, Prop)
	ent:SetColor(255, 0, 0, 255)
end

function TOOL:UnSelectEnt(ent)
	for k, Prop in pairs(self.SelectedProps) do
		if(Prop.ent == ent) then
			Prop.ent:SetColor(Prop.r, Prop.g, Prop.b, Prop.a)
			table.remove(self.SelectedProps, k)
		end
	end
end

function TOOL:CheckEnt(ent)
	local FoundIt = false
	if(table.Count(self.SelectedProps) == 0) then
		return false
	end
	for k, Prop in pairs(self.SelectedProps) do
		if(Prop.ent == ent) then
			FoundIt = true
		end
	end
	return FoundIt
end

function TOOL:ProcessProps()
	if not SERVER then return end

	if (table.Count(self.SelectedProps) > 0) then
		local enablenocollideworld	= self:GetClientNumber("enablenocollideworld")
		local disablenocollideworld	= self:GetClientNumber("disablenocollideworld")
		local enablenocollideall= self:GetClientNumber("enablenocollideall")
		local disablenocollideall= self:GetClientNumber("disablenocollideall")
		local enableshadow	= self:GetClientNumber("enableshadow")
		local disableshadow	= self:GetClientNumber("disableshadow")
		local freeze		= self:GetClientNumber("freeze")
		local unfreeze		= self:GetClientNumber("unfreeze")
		local enablegravity	= self:GetClientNumber("enablegravity")
		local disablegravity	= self:GetClientNumber("disablegravity")
		local changeweight	= self:GetClientNumber("changeweight")
		local weight		= tonumber(self:GetClientNumber("weight"))
		local changematerial	= self:GetClientNumber("changematerial")
		local material		= self:GetClientInfo("material")
		local changecolor	= self:GetClientNumber("changecolor")
		local colorr		= self:GetClientNumber("colorr")
		local colorg		= self:GetClientNumber("colorg")
		local colorb		= self:GetClientNumber("colorb")
		local colora		= self:GetClientNumber("colora")
		local changematerialtexture= self:GetClientNumber("changematerialtexture")
		local materialtexture	= self:GetClientInfo("materialtexture")

		local weld		= self:GetClientNumber("weld")
		local nocollide		= self:GetClientNumber("nocollide")

		undo.Create("quickeverything")
		for key1, prop1 in pairs(self.SelectedProps) do
			if(prop1.ent:IsValid()) then

				if (enablenocollideworld == 1) then
					local nocolconstr = SetAdvBallSocket(prop1, GetWorldEntity())
					undo.AddEntity(nocolconstr)
					prop1.nocolconstr = nocolconstr
				elseif (disablenocollideworld == 1) then
					constraint.RemoveConstraints(prop1.ent,"AdvBallSocket")
				end
				if (enablenocollideall == 1) then
					undo.AddFunction(SetCollisionGroup,prop1.ent,{CollisionGroup = prop1.ent:GetCollisionGroup()})
					SetCollisionGroup(nil, prop1.ent,{CollisionGroup = COLLISION_GROUP_WORLD})
				elseif (disablenocollideall == 1) then
					undo.AddFunction(SetCollisionGroup,prop1.ent,{CollisionGroup = prop1.ent:GetCollisionGroup()})
					SetCollisionGroup(nil, prop1.ent,{CollisionGroup = COLLISION_GROUP_NONE})
				end
				if (enableshadow == 1) then
					undo.AddFunction(SetShadow,prop1.ent,{Shadow = 0})
					SetShadow(self:GetOwner(),prop1.ent,{Shadow = 1})
				elseif (disableshadow == 1) then
					undo.AddFunction(SetShadow,prop1.ent,{Shadow = 1})
					SetShadow(self:GetOwner(),prop1.ent,{Shadow = 0})
				end
				if (freeze == 1) then
					prop1.ent:GetPhysicsObject():EnableMotion(false)
				elseif (freeze == 0) then
					prop1.ent:GetPhysicsObject():EnableMotion(true)
				end
				if (enablegravity == 1) then
					undo.AddFunction(SetGravity,prop1.ent,{Gravity = 0})
					SetGravity(self:GetOwner(),prop1.ent,{Gravity = 1})
				elseif (disablegravity == 1) then
					undo.AddFunction(SetGravity,prop1.ent,{Gravity = 1})
					SetGravity(self:GetOwner(),prop1.ent,{Gravity = 0})
				end
				if (changeweight == 1 && weight > 0) then
					undo.AddFunction(SetMass,prop1.ent,{Mass = prop1.ent:GetPhysicsObject():GetMass()})
					SetMass(self:GetOwner(),prop1.ent,{Mass = weight})
				end
				if (changematerial == 1 && material != "") then
					undo.AddFunction(SetMaterial, prop1.ent, prop1.bone, {Material = prop1.ent:GetPhysicsObject():GetMaterial()})
					SetMaterial(nil, prop1.ent, prop1.bone, {Material = material})
				end
				if (changecolor == 1) then
					local r,g,b,a = prop1.ent:GetColor()
					undo.AddFunction(SetColor, prop1.ent, {R = prop1.r, G = prop1.g, B = prop1.b, A = prop1.a})
					SetColor(nil, prop1.ent, {R = colorr, G = colorg, B = colorb, A = colora})
				end
				if (changematerialtexture == 1 && materialtexture != "") then
					self:GetOwner():PrintMessage(HUD_PRINTTALK, prop1.ent:GetMaterial())
					undo.AddFunction(SetMaterialTexture, prop1.ent, {MaterialTexture = prop1.ent:GetMaterial()})
					SetMaterialTexture(nil, prop1.ent, {MaterialTexture = materialtexture})
				end

				for key2, prop2 in pairs(self.SelectedProps) do
					if(prop2.ent:IsValid() && prop2.ent != prop1.ent) then
						if (weld == 1) then
							undo.AddEntity(constraint.Weld(prop1.ent, prop2.ent, 0, 0, 0))
						end
						if (nocollide == 1) then
							undo.AddEntity(SetAdvBallSocket(prop1, prop2.ent))
							//undo.AddEntity(constraint.NoCollide(prop1.ent, prop2.ent, 0, 0))
						end
					end
				end

			end
		end
		undo.SetCustomUndoText( "Undone Quick Everything")
		undo.SetPlayer(self:GetOwner())
		undo.Finish()
		self:GetOwner():PrintMessage(HUD_PRINTCENTER, "Settings have been applied!")
		if (changecolor == 1) then
			self:ClearSelectedProps(false)
		else
			self:ClearSelectedProps(true)
		end
	end
end

function TOOL:ClearSelectedProps(ResetColor)
	if(table.Count(self.SelectedProps) > 0) then
		if (ResetColor) then
			for k, v in pairs(self.SelectedProps) do
				if(v.ent:IsValid()) then
					v.ent:SetColor(v.r, v.g, v.b, v.a)
				end
			end
		end
		self.SelectedProps = {}
		return true
	else
		return false
	end
end

function IsReallyValid(trace)
	if not trace.Entity:IsValid() then return false end
	if trace.Entity:IsPlayer() then return false end
	if SERVER and not trace.Entity:GetPhysicsObject():IsValid() then return false end
	return true
end

function TOOL:LeftClick(trace) //(De)select props
	if CLIENT and IsReallyValid(trace) then return true end
	if not IsReallyValid(trace) then return false end

	if self:CheckEnt(trace.Entity) then
		self:UnSelectEnt(trace.Entity)
	else
		self:SelectEnt(trace.Entity,trace.PhysicsBone)
	end

	return true;
end

function TOOL:RightClick(trace) //Work
	if CLIENT then return true end

	if table.Count(self.SelectedProps) == 0 then
		self:GetOwner():PrintMessage(HUD_PRINTCENTER, "No props have been selected!")
		return false
	end

	self:ProcessProps()

	return true;
end

function TOOL:Reload(trace) //Clear or reset
	self:ClearSelectedProps(true)
end

function TOOL:Holster()
	if(CLIENT) then return true end
	self:ClearSelectedProps(true)
end

function TOOL:Think()
	if CLIENT then return end;
	local pl = self:GetOwner()
	local wep = pl:GetActiveWeapon()
	if not wep:IsValid() or wep:GetClass() != "gmod_tool" or pl:GetInfo("gmod_toolmode") != "quickeverything" then 
		ClearSelected()
		return
	end
	local trace = pl:GetEyeTrace()
	if not IsReallyValid(trace) then return end
end

function TOOL.BuildCPanel(cp)
	cp:AddControl("Header",   {Text = "#Tool_quickeverything_name", Description = "#Tool_quickeverything_desc"}  )
	cp:AddControl("CheckBox", {Label = "Weld", Command = "quickeverything_weld"})
	cp:AddControl("CheckBox", {Label = "No Collide", Command = "quickeverything_nocollide"})
	cp:AddControl("CheckBox", {Label = "Enable No Collide World", Command = "quickeverything_enablenocollideworld"})
	cp:AddControl("CheckBox", {Label = "Disable No Collide World", Command = "quickeverything_disablenocollideworld"})
	cp:AddControl("CheckBox", {Label = "Enable No Collide All", Command = "quickeverything_enablenocollideall"})
	cp:AddControl("CheckBox", {Label = "Disable No Collide All", Command = "quickeverything_disablenocollideall"})
	cp:AddControl("CheckBox", {Label = "Enable Shadow", Command = "quickeverything_enableshadow"})
	cp:AddControl("CheckBox", {Label = "Disable Shadow", Command = "quickeverything_disableshadow"})
	cp:AddControl("CheckBox", {Label = "Freeze", Command = "quickeverything_freeze"})
	cp:AddControl("CheckBox", {Label = "Unfreeze", Command = "quickeverything_unfreeze"})
	cp:AddControl("CheckBox", {Label = "Enable Gravity", Command = "quickeverything_enablegravity"})
	cp:AddControl("CheckBox", {Label = "Disable Gravity", Command = "quickeverything_disablegravity"})
	cp:AddControl("CheckBox", {Label = "Change Weight", Command = "quickeverything_changeweight"})
	cp:AddControl("Slider",   {Label = "Weight", Type = "Numeric", Min = "1", Max = "50000", Command = "quickeverything_weight"})
	cp:AddControl("CheckBox", {Label = "Change Material (Physical Properties)", Command = "quickeverything_changematerial"})
	cp:AddControl("ComboBox",{
		Label = "Materials",
		Options = {
				["metal bouncy"]={quickeverything_material = "metal_bouncy"},
				["metal"]	={quickeverything_material = "metal"},
				["dirt"]	={quickeverything_material = "dirt"},
				["slime"]	={quickeverything_material = "slipperyslime"},
				["wood"]	={quickeverything_material = "wood"},
				["glass"]	={quickeverything_material = "glass"},
				["concrete"]	={quickeverything_material = "concrete_block"},
				["ice"]		={quickeverything_material = "ice"},
				["rubber"]	={quickeverything_material = "rubber"},
				["paper"]	={quickeverything_material = "paper"},
				["flesh"]	={quickeverything_material = "zombieflesh"},
				["super ice"]	={quickeverything_material = "gmod_ice"},
				["super bouncy"]={quickeverything_material = "gmod_bouncy"}
			}
		}
	)
	cp:AddControl("CheckBox", {Label = "Change Color", Command = "quickeverything_changecolor"})
	cp:AddControl("Color",{
			Label		="Color",
			Red		="quickeverything_colorr",
			Green		="quickeverything_colorg",
			Blue		="quickeverything_colorb",
			Alpha		="quickeverything_colora",
			ShowAlpha	="1",
			ShowHSV		="1",
			ShowRGB		="1",
			Multiplier	="255"
		}
	)
	cp:AddControl("CheckBox", {Label = "Change Material (Texture)", Command = "quickeverything_changematerialtexture"})

	//List of materials.
	list.Add( "OverrideMaterials", "models/wireframe" )
	list.Add( "OverrideMaterials", "debug/env_cubemap_model" )
	list.Add( "OverrideMaterials", "models/shadertest/shader3" )
	list.Add( "OverrideMaterials", "models/shadertest/shader4" )
	list.Add( "OverrideMaterials", "models/shadertest/shader5" )
	list.Add( "OverrideMaterials", "models/shiny" )
	list.Add( "OverrideMaterials", "models/debug/debugwhite" )
	list.Add( "OverrideMaterials", "Models/effects/comball_sphere" )
	list.Add( "OverrideMaterials", "Models/effects/comball_tape" )
	list.Add( "OverrideMaterials", "Models/effects/splodearc_sheet" )
	list.Add( "OverrideMaterials", "Models/effects/vol_light001" )
	list.Add( "OverrideMaterials", "models/props_combine/stasisshield_sheet" )
	list.Add( "OverrideMaterials", "models/props_combine/portalball001_sheet" )
	list.Add( "OverrideMaterials", "models/props_combine/com_shield001a" )
	list.Add( "OverrideMaterials", "models/props_c17/frostedglass_01a" )
	list.Add( "OverrideMaterials", "models/props_lab/Tank_Glass001" )
	list.Add( "OverrideMaterials", "models/props_combine/tprings_globe" )
	list.Add( "OverrideMaterials", "models/rendertarget" )
	list.Add( "OverrideMaterials", "models/screenspace" )
	list.Add( "OverrideMaterials", "brick/brick_model" )
	list.Add( "OverrideMaterials", "models/props_pipes/GutterMetal01a" )
	list.Add( "OverrideMaterials", "models/props_pipes/Pipesystem01a_skin3" )
	list.Add( "OverrideMaterials", "models/props_wasteland/wood_fence01a" )
	list.Add( "OverrideMaterials", "models/props_foliage/tree_deciduous_01a_trunk" )
	list.Add( "OverrideMaterials", "models/props_c17/FurnitureFabric003a" )
	list.Add( "OverrideMaterials", "models/props_c17/FurnitureMetal001a" )
	list.Add( "OverrideMaterials", "models/props_c17/paper01" )
	list.Add( "OverrideMaterials", "models/flesh" )
	list.Add( "OverrideMaterials", "phoenix_storms/metalset_1-2" )
	list.Add( "OverrideMaterials", "phoenix_storms/metalfloor_2-3" )
	list.Add( "OverrideMaterials", "phoenix_storms/plastic" )
	list.Add( "OverrideMaterials", "phoenix_storms/wood" )
	list.Add( "OverrideMaterials", "phoenix_storms/bluemetal" )
	list.Add( "OverrideMaterials", "phoenix_storms/cube" )
	list.Add( "OverrideMaterials", "phoenix_storms/dome" )
	list.Add( "OverrideMaterials", "phoenix_storms/gear" )
	list.Add( "OverrideMaterials", "phoenix_storms/stripes" )
	list.Add( "OverrideMaterials", "phoenix_storms/wire/pcb_green" )
	list.Add( "OverrideMaterials", "phoenix_storms/wire/pcb_red" )
	list.Add( "OverrideMaterials", "phoenix_storms/wire/pcb_blue" )
	list.Add( "OverrideMaterials", "hunter/myplastic" )

	cp:MatSelect("quickeverything_materialtexture", list.Get("OverrideMaterials"), true, 0.33, 0.33)
end